#!/bin/bash

# License: public domain; If you like, please post your improvements or updates to
# https://forum.duplicati.com/t/backup-only-when-host-is-reachable-retry-backup-that-was-missed-due-to-connection-issues/721/4

LOG="/home/dennis/duplicati.log"
F="/home/dennis/duplicati-"$(date +"%F").txt
REMOTEHOST="storage"

echo -e "\n\n\n=== $DUPLICATI__EVENTNAME $DUPLICATI__main_action ======================" >> $LOG
date -R >> $LOG
echo "event: $DUPLICATI__EVENTNAME" >> $LOG
echo "operationname: $DUPLICATI__OPERATIONNAME" >> $LOG
cat $DUPLICATI__RESULTFILE >> $LOG

if [ -e $F ]; then
	echo "## A prior run today was successful/complete. ($F does exist). exit 1" >> $LOG
	exit 1
else
	echo "## No prior successful/complete run today. ($F does not exist). Continuing..." >> $LOG
fi

echo -e "\n\n" >> $LOG


if [ "$DUPLICATI__EVENTNAME" == "BEFORE" ]; then

	ping -c 1 $REMOTEHOST > /dev/null 2>&1
	if [ "$?" == "0" ]; then
		echo "## $REMOTEHOST is up. exit 0" >> $LOG
		exit 0 # run backup!
	else
		echo "## $REMOTEHOST is DOWN. exit 1" >> $LOG
		exit 1 # do not run backup!
	fi




elif [ "$DUPLICATI__EVENTNAME" == "AFTER" ]; then

printenv >> $LOG

	echo "## result is:" >> $LOG

	#check if backup was successful here and
	#only then touch the file:
	grep ParsedResult "$DUPLICATI__RESULTFILE" >> $LOG
	if [ "$?" == "0" ]; then
		echo "## Backup seem successful, creating lockfile $F..." >> $LOG
		touch $F
	else
		echo "## Backup ERROR. Not creating lockfile" >> $LOG
	fi

	cat $DUPLICATI__RESULTFILE >> $F
	exit 0

else

	echo "## ERROR: Unspecified action: $DUPLICATI__EVENTNAME"
	exit 1

fi


exit 1



